use std::{fs::File, io::{BufWriter, Write}};
use anyhow::Result;
use bfox_parser::types::token::Token;

use crate::AsmGen;


pub fn compile_x86_64_nasm(_asm_gen: &mut AsmGen, tokens: Vec<Token>, bw: &mut BufWriter<File>) -> Result<()>{

    writeln!(bw, "BITS 64")?;
    writeln!(bw, "section .text")?;
    writeln!(bw, "_start:")?;

    for t in tokens {
        log::debug!("{t:?}");
    }

    // Exit
    writeln!(bw, "    mov rax, 60")?;
    writeln!(bw, "    mov rdi, 0")?;
    writeln!(bw, "    syscall")?;

    Ok(())
}